CUDNN Frontend API 8.3.0

Public Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
cudnn_frontend::Tensor_v8 Class Reference

`#include <cudnn_frontend_Tensor.h>`

Inheritance diagram for cudnn_frontend::Tensor_v8:
Collaboration diagram for cudnn_frontend::Tensor_v8:

## Public Member Functions
std::string | describe () const override
| Return a string describing the backend Descriptor. More...
int64_t | getPackedElementCount () const
int64_t | getDimensionCount () const
int64_t const * | getDimArray () const
int64_t const * | getStrideArray () const
int64_t | getDataType () const
| Tensor_v8 (Tensor_v8 &&from)=default
Tensor_v8 & | operator= (Tensor_v8 &&)=default
| ~Tensor_v8 ()=default
Public Member Functions inherited from cudnn_frontend::BackendDescriptor
cudnnBackendDescriptor_t | get_raw_desc () const
cudnnStatus_t | get_status () const
| Current status of the descriptor. More...
void | set_status (cudnnStatus_t const status_) const
| Set status of the descriptor. More...
void | set_error (const char *message) const
| Set Diagonistic error message. More...
const char * | get_error () const
| Diagonistic error message if any. More...
ManagedOpaqueDescriptor | get_desc () const
| Returns a copy of underlying managed descriptor. More...
cudnnStatus_t | initialize_managed_backend_pointer (cudnnBackendDescriptorType_t type)
| Initializes the underlying managed descriptor. More...

## Private Member Functions
| Tensor_v8 ()=default
| Tensor_v8 (Tensor_v8 const &)=delete
Tensor_v8 & | operator= (Tensor_v8 const &)=delete

## Private Attributes
cudnnDataType_t | data_type = CUDNN_DATA_FLOAT
int64_t | btensor_dimA [CUDNN_DIM_MAX+1] = {-1}
| Datatype of the elements. More...
int64_t | btensor_strA [CUDNN_DIM_MAX+1] = {-1}
| n, g, c, d, h, w More...
int64_t | id = -1
| n, g, c, d, h, w More...
int64_t | alignment = -1
| Unique id of the tensor. More...
int64_t | nDims = -1
| Certain engine config expect minimum alignment of 16B. More...
int64_t | vectorDimension = -1
| Number of Dimensions of the tensor. More...
int64_t | vectorCount = 1
| Which dimension of the tensor is vectorized (Generally the c dim) More...
bool | isVirtual = false
| What is the vectorization count (4 or 32) More...
bool | isByValue = false
| Whether it is an intermediate tensor of an op graph. More...

## Friends
class | TensorBuilder_v8

## Additional Inherited Members
Protected Member Functions inherited from cudnn_frontend::BackendDescriptor
| BackendDescriptor (ManagedOpaqueDescriptor pointer_, cudnnStatus_t status_, std::string err_msg_)
| BackendDescriptor ()=default
Protected Attributes inherited from cudnn_frontend::BackendDescriptor
ManagedOpaqueDescriptor | pointer
cudnnStatus_t | status = CUDNN_STATUS_SUCCESS
| Shared pointer of the OpaqueBackendPointer. More...
std::string | err_msg
| Error message if any being set. More...

## Detailed Description

Tensor_v8 Class This class tells the properties of the Tensor_v8 on which the operation will be performed Properties:

- dataType
- alignment
- unique identifier
- tensor dimensions
- tensor strides
- isVirtual
- isByValue

Use TensorBuilder_v8 to build this class. Describe returns a string describing the tensor class

Definition at line 52 of file cudnn_frontend_Tensor.h.

## Constructor & Destructor Documentation

## ◆ Tensor_v8() [1/3]

cudnn_frontend::Tensor_v8::Tensor_v8 | ( | Tensor_v8 && | from | ) |
| default

## ◆ ~Tensor_v8()

cudnn_frontend::Tensor_v8::~Tensor_v8 | ( |  | ) |
| default

Referenced by getDataType().

## ◆ Tensor_v8() [2/3]

cudnn_frontend::Tensor_v8::Tensor_v8 | ( |  | ) |
| privatedefault

Referenced by getDataType().

## ◆ Tensor_v8() [3/3]

cudnn_frontend::Tensor_v8::Tensor_v8 | ( | Tensor_v8 const & |  | ) |
| privatedelete

## Member Function Documentation

## ◆ describe()

std::string cudnn_frontend::Tensor_v8::describe | ( |  | ) | const
| inlineoverridevirtual

Return a string describing the backend Descriptor.

Implements cudnn_frontend::BackendDescriptor.

Definition at line 56 of file cudnn_frontend_Tensor.h.

References alignment, btensor_dimA, btensor_strA, data_type, isByValue, isVirtual, nDims, cudnn_frontend::to_string(), nlohmann::to_string(), vectorCount, and vectorDimension.

## ◆ getDataType()

int64_t cudnn_frontend::Tensor_v8::getDataType | ( |  | ) | const
| inline

Definition at line 105 of file cudnn_frontend_Tensor.h.

References data_type, operator=(), Tensor_v8(), and ~Tensor_v8().

## ◆ getDimArray()

int64_t const* cudnn_frontend::Tensor_v8::getDimArray | ( |  | ) | const
| inline

Definition at line 95 of file cudnn_frontend_Tensor.h.

References btensor_dimA.

Referenced by cudnn_frontend::cudnnReorderFilterAndBiasInt8x32().

## ◆ getDimensionCount()

int64_t cudnn_frontend::Tensor_v8::getDimensionCount | ( |  | ) | const
| inline

Definition at line 90 of file cudnn_frontend_Tensor.h.

References nDims.

Referenced by cudnn_frontend::cudnnReorderFilterAndBiasInt8x32().

## ◆ getPackedElementCount()

int64_t cudnn_frontend::Tensor_v8::getPackedElementCount | ( |  | ) | const
| inline

Definition at line 81 of file cudnn_frontend_Tensor.h.

References btensor_dimA, nDims, and vectorCount.

## ◆ getStrideArray()

int64_t const* cudnn_frontend::Tensor_v8::getStrideArray | ( |  | ) | const
| inline

Definition at line 100 of file cudnn_frontend_Tensor.h.

References btensor_strA.

## ◆ operator=() [1/2]

Tensor_v8& cudnn_frontend::Tensor_v8::operator= | ( | Tensor_v8 && |  | ) |
| default

Referenced by cudnn_frontend::TensorBuilder_v8::build(), and getDataType().

## ◆ operator=() [2/2]

Tensor_v8& cudnn_frontend::Tensor_v8::operator= | ( | Tensor_v8 const & |  | ) |
| privatedelete

## Friends And Related Function Documentation

## ◆ TensorBuilder_v8

friend class TensorBuilder_v8
| friend

Definition at line 54 of file cudnn_frontend_Tensor.h.

Referenced by cudnn_frontend::TensorBuilder_v8::build().

## Member Data Documentation

## ◆ alignment

int64_t cudnn_frontend::Tensor_v8::alignment = -1
| private

Unique id of the tensor.

Definition at line 125 of file cudnn_frontend_Tensor.h.

Referenced by describe().

## ◆ btensor_dimA

int64_t cudnn_frontend::Tensor_v8::btensor_dimA[CUDNN_DIM_MAX+1] = {-1}
| private

Datatype of the elements.

Definition at line 122 of file cudnn_frontend_Tensor.h.

Referenced by describe(), getDimArray(), and getPackedElementCount().

## ◆ btensor_strA

int64_t cudnn_frontend::Tensor_v8::btensor_strA[CUDNN_DIM_MAX+1] = {-1}
| private

n, g, c, d, h, w

Definition at line 123 of file cudnn_frontend_Tensor.h.

Referenced by describe(), and getStrideArray().

## ◆ data_type

cudnnDataType_t cudnn_frontend::Tensor_v8::data_type = CUDNN_DATA_FLOAT
| private

Definition at line 121 of file cudnn_frontend_Tensor.h.

Referenced by describe(), and getDataType().

## ◆ id

int64_t cudnn_frontend::Tensor_v8::id = -1
| private

n, g, c, d, h, w

Definition at line 124 of file cudnn_frontend_Tensor.h.

## ◆ isByValue

bool cudnn_frontend::Tensor_v8::isByValue = false
| private

Whether it is an intermediate tensor of an op graph.

Definition at line 131 of file cudnn_frontend_Tensor.h.

Referenced by describe().

## ◆ isVirtual

bool cudnn_frontend::Tensor_v8::isVirtual = false
| private

What is the vectorization count (4 or 32)

Definition at line 130 of file cudnn_frontend_Tensor.h.

Referenced by describe().

## ◆ nDims

int64_t cudnn_frontend::Tensor_v8::nDims = -1
| private

Certain engine config expect minimum alignment of 16B.

Alignment of the tensor.

Definition at line 127 of file cudnn_frontend_Tensor.h.

Referenced by describe(), getDimensionCount(), and getPackedElementCount().

## ◆ vectorCount

int64_t cudnn_frontend::Tensor_v8::vectorCount = 1
| private

Which dimension of the tensor is vectorized (Generally the c dim)

Definition at line 129 of file cudnn_frontend_Tensor.h.

Referenced by describe(), and getPackedElementCount().

## ◆ vectorDimension

int64_t cudnn_frontend::Tensor_v8::vectorDimension = -1
| private

Number of Dimensions of the tensor.

Definition at line 128 of file cudnn_frontend_Tensor.h.

Referenced by describe().

The documentation for this class was generated from the following file:

- cudnn_frontend_Tensor.h